#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> random_models;

const int maxT = 1000 * 1000 * 1000;

void gen(int n) {
    for(int i = 0; i < n; i++) {
        cout << random_models.back();
        random_models.pop_back();
        if(i < n - 1){
            cout << ' ';
        }
    }
    cout << '\n';
}

void gen_models(int n, int mi, int ma) {
    if(n > ma - mi + 1) {
        if(mi + n < maxT) {
            ma = mi + n;
        }
        else {
            mi = ma - n;
        }
    }
    if(ma - mi - 5 > n * 2) {
        set<int> num;
        for(int i = 0; i < n; i++) {
            int t = -1;
            while(t == -1 || num.count(t)) {
                t = rnd.next(mi, ma);
            }
            num.insert(t);
            random_models.push_back(t);
        }
    }
    else {
        vector<int> T;
        for(int i = mi; i <= ma; i++) {
            T.push_back(i);
        }
        shuffle(T.begin(), T.end());
        for(int i = 0; i < n; i++) {
            random_models.push_back(T[i]);
        }
    }
}

int main(int argc, char* argv[]){
	registerGen(argc, argv, 1);
	int g = atoi(argv[1]);
	int r = atoi(argv[2]);
	int b = atoi(argv[3]);
    int mi = atoi(argv[4]);
    int ma = atoi(argv[5]);
    gen_models(g + r + b, mi, ma);
    cout << g << ' ' << r << ' ' << b << '\n';
    gen(g);
    gen(r);
    gen(b);
}