#include <bits/stdc++.h>
using namespace std;
const int INF = (int)(1e9);

pair<int, pair<string, string> > solve(int n, int x, int y, function<int(int, int)> better) {
	int neutral = better(-INF, INF) ? INF : -INF;

	vector<vector<int> > dp(n + 2, vector<int>(16, neutral));
	vector<vector<int> > p(n + 2, vector<int>(16, -1));
	dp[0][0] = 0;
	for (int i = 0; i <= n; i++) {
		for (int mask = 0; mask < 16; mask++) {
			if (dp[i][mask] == neutral) continue;
			for (int nw = 0; nw < 4; nw++) {
				vector<vector<int> > a(2, vector<int>(3));
				for (int j = 0; j < 4; j++) a[j % 2][j / 2] = (mask >> j) & 1;
				for (int j = 0; j < 2; j++) a[j % 2][2] = (nw >> j) & 1;

				bool ok = 1;
				if (i > 0) for (int j = 0; j < 2; j++) {
					vector<int> cnt(2);
					cnt[a[j ^ 1][1]]++;
					if (i > 1) cnt[a[j][0]]++;
					if (i < n) cnt[a[j][2]]++;
					bool cok = 1;
					cok &= x == -1 || cnt[0] == y;
					cok &= y == -1 || cnt[1] == x;
					cok ^= a[j][1] ^ 1;
					ok &= cok;
				}
				if (ok) {
					int nmask = (mask >> 2) ^ (nw << 2);
					int ndp = dp[i][mask] + (i != n) * (a[0][2] + a[1][2]);
					if (better(ndp, dp[i + 1][nmask])) {
						dp[i + 1][nmask] = ndp;
						p[i + 1][nmask] = mask;
					}
				}
			}
		}
	}
	int cx = n + 1;
	int mask = 0;
	for (int i = 0; i < 16; i++) if (better(dp[n + 1][i], dp[n + 1][mask])) mask = i;

	if (dp[n + 1][mask] == neutral) return make_pair(-1, make_pair("", ""));

	int res = dp[n + 1][mask];
	string a, b;
	while (cx > 0) {
		if (cx < n + 1) {
			a += (char)('0' + ((mask >> 2) & 1));
			b += (char)('0' + ((mask >> 3) & 1));
		}
		mask = p[cx][mask];
		cx--;
	}
	return make_pair(res, make_pair(a, b));
}

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);

	int n, x, y;
	while (cin >> n >> x >> y) {
		auto ans1 = solve(n, x, y, [&](int i, int j) { return i < j; });
		auto ans2 = solve(n, x, y, [&](int i, int j) { return i > j; });
		cout << ans1.first << endl << ans1.second.first << endl << ans1.second.second << endl;
		cout << ans2.first << endl << ans2.second.first << endl << ans2.second.second << endl;
	}

	return 0;
}