#include "testlib.h"
#include <iostream>
#include <cstdio>
#include <fstream>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <set>
using namespace std;

const int MAXN = (int)1e5;
const int MAXEL = (int)1e9;

int f[MAXN];

void gen(int n) 
{
    cout << n << endl;
    int sum = 0;
    for (int i = 0; i < n - 1; i++)
    {
        f[i] = rnd.next(max(-MAXEL, -MAXEL - sum), min(MAXEL, MAXEL - sum));
        sum += f[i];
    }
    f[n - 1] = sum;
    int ind = rnd.next(0, n - 1);
    swap(f[n - 1], f[ind]);

    for (int i = 0; i < n; i++)
    {
        cout << f[i];
        if (i < n - 1)
            cout << " ";
    }
    cout << endl;
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    //int minEl = atoi(argv[2]);
    //int maxEl = atoi(argv[3]);
    gen(n);
    return 0;
}